#pragma once

#include "vault.h"
#include "FL/glut.h"
#include "model.h"
#include "modelerdraw.h"

#define UPPER_ARM_RADIUS 2
#define UPPER_ARM_LENGTH 7.5
#define ELBOW_RADIUS 1.2
#define LOWER_ARM_RADIUS 0.75
#define LOWER_ARM_LENGTH 9
#define HAND_LENGTH 3
#define HAND_WIDTH 2
#define HAND_DEPTH 0.6

// Arm model: Upper arm connected to a lower arm conntected to a hand.
// The arm is drawn from the origin extending in the positive z-direction.
class ArmModel : public Model {
private:
	// Add Properties, Shaders, Textures here
	RangeProperty arm_rotation_x, upper_arm_angle, lower_arm_angle, hand_angle;
	RGBProperty upper_arm_color, lower_arm_color, hand_color;
public:
	ArmModel(const char* name);
	// Override any of the functions in model.h to implement your own functionality.
	virtual void draw();

	// scalar set by FalconModel, determines scaling in width and depth, NOT height
	float muscle_mass;

	// FalconModel needs access to this slider's value because the rotation needs
	// to be done outside of ArmModel, since it's reversed for left vs right arms.
	RangeProperty arm_rotation_y;
};