#pragma once

#include "vault.h"
#include "FL/glut.h"
#include "model.h"
#include "modelerdraw.h"

#define UPPER_LEG_RADIUS 3
#define UPPER_LEG_LENGTH 10.5
#define KNEE_RADIUS 2
#define LOWER_LEG_RADIUS 1
#define LOWER_LEG_LENGTH 11.5
#define FOOT_WIDTH 2
#define FOOT_HEIGHT 1.5
#define FOOT_LENGTH 4

// Leg model: Upper leg connected to a lower leg conntected to a foot.
// The leg is drawn from the origin extending in the positive z-direction.
class LegModel : public Model {
private:
	// Add Properties, Shaders, Textures here
	RangeProperty leg_rotation, upper_leg_angle, lower_leg_angle, foot_angle;
	RGBProperty upper_leg_color, lower_leg_color, foot_color;

public:
	LegModel(const char* name);
	// Override any of the functions in model.h to implement your own functionality.
	virtual void draw();

	float muscle_mass;  // see armmodel.h
};